/************************************************************

	OzTclTk.c
	
	Implementation of Tcl commands for TkOzAPI

******************************************************/


#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <tcl.h>
#include "OzAPI.h"
#include "TkOzAPI.h"

extern int Et_EvalTrace;

int ET_COMMAND_OzStart(ET_TCLARGS)
{
	FILE* fp;

	#ifdef DEBUG
	printf ("OzStart!!!\n");
	Et_EvalTrace = 1;
	#else
	Et_EvalTrace = 0;
	fp = fopen("/dev/null", "w");
	if (fp)
		stdout = fp;  // stop Tcl output
	#endif


	ozinit_(); // FORTRAN START

	return TCL_OK;
}

int ET_COMMAND_OzMenu(ET_TCLARGS)
{
	int code;
	int pull;
	int item;

	if (argc!=4)
	{
		Et_ResultF(interp, 
			"Illegal call, should be OzMenu <pullDown> <item> <code>");
		return TCL_ERROR;
	}
	pull = atoi(argv[1]);
	item = atoi(argv[2]);
	code = atoi(argv[3]);

	#ifdef DEBUG
	printf ("OzMenu %d %d %d\n", pull, item, code);
	#endif

	ozmenucb_ (&pull, &item, &code);
		
	return TCL_OK;
}
	

int ET_COMMAND_OzResults(ET_TCLARGS)
{

	if (argc!=2)
	{
		Et_ResultF(interp, 
			"Illegal call, should be OzResults <result>");
		return TCL_ERROR;
	}

	if (ozResult)
		free (ozResult);
	ozResult = malloc(strlen(argv[1])+1);
	if (!ozResult)
		OzFatalError("Failed to allocate memory");

	strcpy(ozResult, argv[1]);

	#ifdef DEBUG
	printf ("OzResults %s\n", ozResult);
	#endif

	return TCL_OK;
}
